#include <Time.h>  
#include <TM1638.h>
#include <Fat16util.h>
#include <NewSPI.h>
#include "MusicPlayer.h"

//Подключение 
//  VCC LCD - 5V Arduino
//  GND LCD - GND Arduino
//  CLC LCD - Pin 9 Arduino
//  DIO LCD - Pin 8 Arduino
//  STB0 LCD - Pin 7 Arduino


// D5 - датчик приближения
// D4 - IR приемник

// Создаём объект для управления плейером
MusicPlayer myplayer;

// define a module on data pin 8, clock pin 9 and strobe pin 7
TM1638 module(8, 9, 7);
unsigned long a=1;
int popravka=0;
int buttons;
boolean dot;
boolean valSens;
boolean isDebug=false;
int currentHour;
String strHour;
String strMinute;
String strDay;
String strMonth;
#define TIME_MSG_LEN  11   // time sync to PC is HEADER followed by Unix time_t as ten ASCII digits
#define TIME_HEADER  'T'   // Header tag for serial time sync message
#define TIME_REQUEST  7    // ASCII bell character requests a time sync message 
int irIn = 4; //PIN для подключения входа IR датчика
int sensIn = 5; //
int valIr = 0;
long previousMillis = 0;
long interval = 86400000; //интервал сутки в милисекундах

// T1262347200  //noon Jan 1 2010

void setup()  {

  myplayer.begin(); 
  myplayer.setPlayMode(MODE_NORMAL);
  //myplayer.analogControlDisable();
  dot=true;
  Serial.begin(9600);
  setTime(0,00,00,01,01,2012);
  
   myplayer.keyDisable(); //отключаем встроенное управление воспроизведением
   pinMode(irIn, INPUT);
   pinMode(sensIn, INPUT);
   int valIr = 1;
  myplayer.setPlayMode(MODE_NORMAL);
  myplayer.setVolume(1);
}

void loop(){    
 unsigned long currentMillis = millis();
  digitalClockDisplay(); 
  buttons=module.getButtons(); 
  if (isDebug) {Serial.println(buttons);}
   if (buttons==2) {
    adjustTime(60);
    }  else if (buttons==1) {adjustTime(60*60);  
  } else if ((buttons==4)||(buttons==8)) {
    enterPopravka(); //процедура ввода поправки
  }
    
      delay(100);
   valIr = digitalRead(irIn);
   valSens = digitalRead(sensIn);
   if (isDebug) {Serial.println(valIr);}
   if ((valIr == 0) or (!valSens)) {sayTime();}
   
   //Корректируем время
   //Проверяем не смнился ли час и если сменился вводим поправку
   if(currentMillis - previousMillis > interval) {
    // save the last time you blinked the LED 
    previousMillis = currentMillis;  
    adjustTime(popravka); //каждый час поправляю на 
  }
    
  }
  
void enterPopravka() { //Вводим пправку
if (buttons==4) { popravka++;
} else {
  popravka--;}
 module.clearDisplay();
  module.setDisplayToString(String(popravka), 0b01000000); 
 delay(400);
 printDigits(popravka);
}

void digitalClockDisplay(){
  // digital clock display of the time
  printDigits(minute());
  printDigits(second());
  if (isDebug) {
    Serial.print(hour());
    Serial.print(" ");
    Serial.print(day());
    Serial.print(" ");
    Serial.print(month());
    Serial.print(" ");
    Serial.print(year()); 
    Serial.println(); 
  }
  //перевожу часы в стринг
  if (hour()==0) {
   strHour="00"; }
  if (hour()<10) {
   strHour=String("0")+hour();}
  else {
   strHour= String(hour());}
  //перевожу минуты в стринг
if (minute()==0) {
   strMinute="00"; }
  if (minute()<10) {
   strMinute=String("0")+minute();}
  else {
   strMinute= String(minute());}
  
 //мигаю точькой  
  if (dot) {
  module.setDisplayToString(strHour+strMinute, 0b01000000); 
  dot=false;
  } else {
   module.setDisplayToString(strHour+strMinute, 0b00000000);   
//   module.setDisplayToDecNumber(hour()*100+minute(),0,false); 
   dot=true;
  }

}

void printDigits(int digits){
  // utility function for digital clock display: prints preceding colon and leading 0
  if (isDebug) {
  Serial.print(":");
  if(digits < 10)
    Serial.print('0');
  Serial.print(digits);
  }
}

void processSyncMessage() {
  // if time sync available from serial port, update time and return true
  while(Serial.available() >=  TIME_MSG_LEN ){  // time message consists of header & 10 ASCII digits
    char c = Serial.read() ; 
    Serial.print(c);  
    if( c == TIME_HEADER ) {       
      time_t pctime = 0;
      for(int i=0; i < TIME_MSG_LEN -1; i++){   
        c = Serial.read();          
        if( c >= '0' && c <= '9'){   
          pctime = (10 * pctime) + (c - '0') ; // convert digits to a number    
        }
      }   
      setTime(pctime);   // Sync Arduino clock to the time received on the serial port
      setTime(17,30,00,28,11,2012);
    }  
  }
}

void sayTime(){
  int chas_ov_a; //1 - час, 2 - часа , 3 -часов
  int minut_a_i; //1 - миинут, 2 - минута , 3 -минуты
  int minut;
  
  myplayer.begin(); 
  myplayer.setPlayMode(MODE_NORMAL);
  myplayer.setVolume(1);
  // Сказать столько времени
 // Serial.print("YES");
  
      switch (hour()) {
     case 0:
    myplayer.playSong("0.mp3");
    chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;
    case 1:
    myplayer.playSong("1.mp3");
    chas_ov_a=1;
      break;
    case 2:
    myplayer.playSong("2.mp3");
    chas_ov_a=2;//1 - час, 2 - часа , 3 -часов
      break;
   case 3:
    myplayer.playSong("3.mp3");
    chas_ov_a=2;//1 - час, 2 - часа , 3 -часов
      break;
   case 4:
    myplayer.playSong("4.mp3");
    chas_ov_a=2;//1 - час, 2 - часа , 3 -часов
      break;     
    case 5:
    myplayer.playSong("5.mp3");
    chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;   
     case 6:
    myplayer.playSong("6.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break; 
   case 7:
    myplayer.playSong("7.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;       
    case 8:
    myplayer.playSong("8.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;     
     case 9:
    myplayer.playSong("9.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;     
     case 10:
    myplayer.playSong("10.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;     
       case 11:
    myplayer.playSong("11.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;   
     case 12:
    myplayer.playSong("12.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;     
      case 13:
    myplayer.playSong("13.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;    
       case 14:
    myplayer.playSong("14.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break; 
     case 15:
    myplayer.playSong("15.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;    
      case 16:
    myplayer.playSong("16.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;    
     case 17:
    myplayer.playSong("17.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;     
     case 18:
    myplayer.playSong("18.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;  
    case 19:
    myplayer.playSong("19.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;      
     case 20:
    myplayer.playSong("20.mp3");
     chas_ov_a=3;//1 - час, 2 - часа , 3 -часов
      break;  
    case 21:
    myplayer.playSong("21.mp3");
     chas_ov_a=1;//1 - час, 2 - часа , 3 -часов
      break;  
   case 22:
    myplayer.playSong("22.mp3");
     chas_ov_a=2;//1 - час, 2 - часа , 3 -часов
      break; 
 case 23:
    myplayer.playSong("23.mp3");
     chas_ov_a=2;//1 - час, 2 - часа , 3 -часов
      break;   
 case 24:
    myplayer.playSong("24.mp3");
     chas_ov_a=2;//1 - час, 2 - часа , 3 -часов
      break;         
   }
   
    switch (chas_ov_a) {
    case 1:
    myplayer.playSong("hour.mp3");
    break;
    case 2:
    myplayer.playSong("houra.mp3");
    break;
   case 3:
    myplayer.playSong("hours.mp3");
    break;
       }
    
    minut=minute();
    
     minut_a_i=0;   
    switch (minut) { 
   case 0: 
     myplayer.playSong("0m.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
    case 1: 
     myplayer.playSong("1a.mp3");
     minut_a_i=2; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 2: 
     myplayer.playSong("2e.mp3");
     minut_a_i=3; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 3: 
     myplayer.playSong("3.mp3");
     minut_a_i=3; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 4: 
     myplayer.playSong("4.mp3");
     minut_a_i=3; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 5: 
     myplayer.playSong("5.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 6: 
     myplayer.playSong("6.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 7: 
     myplayer.playSong("7.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 8: 
     myplayer.playSong("8.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 9: 
     myplayer.playSong("9.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break; 
      case 10: 
     myplayer.playSong("10.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;   
       case 11: 
     myplayer.playSong("11.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 12: 
     myplayer.playSong("12.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 13: 
     myplayer.playSong("13.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 14: 
     myplayer.playSong("14.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 15: 
     myplayer.playSong("15.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 16: 
     myplayer.playSong("16.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 17: 
     myplayer.playSong("17.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 18: 
     myplayer.playSong("18.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break; 
      case 19: 
     myplayer.playSong("19.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;   
    }
   
   if ( minut_a_i!=0) {
     switch (minut_a_i) { 
    case 1: 
     myplayer.playSong("minuts.mp3");
     break;  
      case 2:    
       myplayer.playSong("minut.mp3");
     break;
     case 3:    
       myplayer.playSong("minuti.mp3");
     break; 
     }
   }
     if (minut>=20) {
      switch (minut) { 
    case 20: 
     myplayer.playSong("20.mp3");
     break;  
      case 30: 
     myplayer.playSong("30.mp3");
     break;  
      case 40: 
     myplayer.playSong("40.mp3");
     break;  
      case 50: 
     myplayer.playSong("50.mp3");
     break;  
      }
      if ((minut>20)&(minut<30)) {
         myplayer.playSong("20.mp3");
      } else if ((minut>30)&(minut<40)) {
       myplayer.playSong("30.mp3");
      } else if ((minut>40)&(minut<50)) {  
         myplayer.playSong("40.mp3");
      } else if (minut>50) {
        myplayer.playSong("50.mp3");
      }
      if (minut%10>0) {
        ostatok(minut%10);
      } else {
       myplayer.playSong("minuts.mp3");
      }
    }
         
  } 
   //myplayer.playSong("1.mp3");//play a song named with test.wav
 //while(1);


void ostatok(int minut)
{
  int minut_a_i;
   switch (minut) { 
    case 1: 
     myplayer.playSong("1a.mp3");
     minut_a_i=2; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 2: 
     myplayer.playSong("2e.mp3");
     minut_a_i=3; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 3: 
     myplayer.playSong("3.mp3");
     minut_a_i=3; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 4: 
     myplayer.playSong("4.mp3");
     minut_a_i=3; //1 - миинут, 2 - минута , 3 -минуты
    break;  
      case 5: 
     myplayer.playSong("5.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 6: 
     myplayer.playSong("6.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 7: 
     myplayer.playSong("7.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 8: 
     myplayer.playSong("8.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;  
       case 9: 
     myplayer.playSong("9.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break; 
      case 10: 
     myplayer.playSong("10.mp3");
     minut_a_i=1; //1 - миинут, 2 - минута , 3 -минуты
    break;   
   }
   
    if ( minut_a_i!=0) {
     switch (minut_a_i) { 
    case 1: 
     myplayer.playSong("minuts.mp3");
     break;  
      case 2:    
       myplayer.playSong("minut.mp3");
     break;
     case 3:    
       myplayer.playSong("minuti.mp3");
     break; 
     }
   }
}
